Crystal Space: csScfStringSet Class Reference (Crystal Space Public API Reference)

| ## Public API Reference

- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# csScfStringSet Class Reference

The string set is a collection of unique strings. More...

`#include <csutil/scfstrset.h>`

Inheritance diagram for csScfStringSet:

[legend]
List of all members.

## Public Member Functions
virtual void | Clear ()
| Remove all stored strings.
virtual bool | Contains (csStringID id) const
| Check if the set contains a string with a particular ID.
virtual bool | Contains (char const *s) const
| Check if the set contains a particular string.
| csScfStringSet (size_t size=23)
| Constructor.
virtual bool | Delete (csStringID id)
| Remove a string with the specified ID.
virtual bool | Delete (char const *s)
| Remove specified string.
virtual void | Empty ()
| Remove all stored strings.
virtual size_t | GetSize () const
| Get the number of elements in the hash.
virtual bool | IsEmpty () const
| Return true if the hash is empty.
virtual const char * | Request (csStringID id) const
| Request the string corresponding to the given ID.
virtual csStringID | Request (const char *s)
| Request the numeric ID for the given string.
virtual | ~csScfStringSet ()
| Destructor.

## Detailed Description

The string set is a collection of unique strings.

Each string has an ID number. The most important operation is to request a string, which means to return the ID for the string, adding it to the collection if not already present. This is useful when you need to work with strings but want the performance characteristics of simple numeric comparisons. Rather than performing string comparisons, you instead compare the numeric string ID's.

Definition at line 39 of file scfstrset.h.

## Constructor & Destructor Documentation

csScfStringSet::csScfStringSet | ( | size_t | size = `23` | ) | `[inline]`

Constructor.

Definition at line 47 of file scfstrset.h.

virtual csScfStringSet::~csScfStringSet | ( |  | ) | `[inline, virtual]`

Destructor.

Definition at line 52 of file scfstrset.h.

## Member Function Documentation

virtual void csScfStringSet::Clear | ( |  | ) | `[inline, virtual]`

Remove all stored strings.

Implements iStringSet.

Definition at line 110 of file scfstrset.h.

virtual bool csScfStringSet::Contains | ( | csStringID | id | ) | const`[inline, virtual]`

Check if the set contains a string with a particular ID.

Remarks:
  This is rigidly equivalent to `return Request(id) != NULL`, but more idomatic.

Implements iStringSet.

Definition at line 83 of file scfstrset.h.

virtual bool csScfStringSet::Contains | ( | char const * | s | ) | const`[inline, virtual]`

Check if the set contains a particular string.

Implements iStringSet.

Definition at line 75 of file scfstrset.h.

virtual bool csScfStringSet::Delete | ( | csStringID | id | ) | `[inline, virtual]`

Remove a string with the specified ID.

Returns:
  True if a matching string was in thet set; else false.

Implements iStringSet.

Definition at line 97 of file scfstrset.h.

virtual bool csScfStringSet::Delete | ( | char const * | s | ) | `[inline, virtual]`

Remove specified string.

Returns:
  True if a matching string was in thet set; else false.

Implements iStringSet.

Definition at line 90 of file scfstrset.h.

virtual void csScfStringSet::Empty | ( |  | ) | `[inline, virtual]`

Remove all stored strings.

When new strings are registered again, new ID values will be used; the old ID's will not be re-used.

Implements iStringSet.

Definition at line 104 of file scfstrset.h.

virtual size_t csScfStringSet::GetSize | ( |  | ) | const`[inline, virtual]`

Get the number of elements in the hash.

Implements iStringSet.

Definition at line 114 of file scfstrset.h.

virtual bool csScfStringSet::IsEmpty | ( |  | ) | const`[inline, virtual]`

Return true if the hash is empty.

Remarks:
  Rigidly equivalent to `return GetSize() == 0`, but more idiomatic.

Implements iStringSet.

Definition at line 122 of file scfstrset.h.

virtual const char* csScfStringSet::Request | ( | csStringID | id | ) | const`[inline, virtual]`

Request the string corresponding to the given ID.

Returns:
  Null if the string has not been requested (yet), else the string corresponding to the ID.

Implements iStringSet.

Definition at line 69 of file scfstrset.h.

virtual csStringID csScfStringSet::Request | ( | const char * | s | ) | `[inline, virtual]`

Request the numeric ID for the given string.

Returns:
  The ID of the string.

Remarks:
  Creates a new ID if the string is not yet present in the set, else returns the previously assigned ID.

Implements iStringSet.

Definition at line 61 of file scfstrset.h.

The documentation for this class was generated from the following file:

- csutil/scfstrset.h